rm(list=ls())

# R code:  parallel version of OLS monte carlo code


library(snow)

library(Rmpi)

nclus=6

cl <-makeMPIcluster(nclus)

 

#alter either n or mc to affect run time

n=2000

mc=20000

mcperclus=round(mc/nclus)

 

x=matrix(runif(n),n,1)

x=cbind(1,x)

 

estimatebetas=function(x,n,nmc){

  e=matrix(rnorm(n*nmc),n,nmc)

  y=1+rep(x[,2],nmc)+e

  solve(t(x)%*%x)%*%t(x)%*%y

  }

 

ptim=proc.time()[3]

b=clusterCall(cl,estimatebetas,x=x,n=n,nmc=mcperclus)

b=cbind(b[[1]],b[[2]],b[[3]],b[[4]],b[[5]],b[[6]])

#print(b)

tim=proc.time()[3]-ptim

 

cat(dim(b),"  ",apply(b,1,mean),"\n")

cat(mc," iterations with sample sizes of ",n," took ",tim,"seconds.\n")
stopCluster(cl)
